$(function() {
    $('.ui-help a').click(function() {
        var base_url = $(this).attr('href');
        var dialog = $('<div id="yelp"><iframe src="' + base_url + '"></iframe></div>').dialog({
                    modal: true,
                    resizable: false,
                    position: {my: "right top", at: "right top"},
                    title: '',
                    width: '50%'});
        $(dialog).css('height', ($(window).height() - 80) + 'px');
        return false;
    });
    $('.foldable').click(function() {
       $(this).toggleClass('folded').next().toggle();
       $(this).next().find('.qommon-map').trigger('qommon:invalidate');
    });
    $('.foldable.folded').next().hide();

    /* insert variable code in textarea when clicking on them */
    $('#substvars td:nth-child(2)').css('cursor', 'pointer').click(function() {
       var current_val = $('textarea').val();
       position = $('textarea').get(0).selectionStart;
       if (position >= 0) {
         var code = $(this).text();
         var new_val = current_val.substr(0, position) + code + current_val.substr(position);
         $('textarea').val(new_val);
       }
       return true;
    });

    /* open theme preview in a iframe */
    $('a.theme-preview').click(function() {
        var html = '<div id="theme-preview"><iframe src="' + $(this).attr('href') + '"></iframe></div>';
        var title = $(this).parent().parent().find('label').text()
        var dialog = $(html).dialog({modal: true, title: title,
                width: $(window).width() - 180,
                height: $(window).height() - 80
        });
        return false;
    });

    /* highlight info text on hover */
    $('.action-info-text[data-button-name]').each(function(idx, elem) {
        $('[name=' + $(elem).data('button-name') + ']').on('mouseenter', function() {
           $(elem).addClass('highlight');
        }).on('mouseleave', function() {
           $(elem).removeClass('highlight');
        });
    });

    /* keep sidebar sticky */
    if ($('#sidebar').length) {
      var $window = $(window);
      var sidebar_fixed_from = $('#sidebar').offset().top;
      var sidebar_top = $('#sidebar').position().top;
      $window.bind('scroll', function() {
        var pos = $window.scrollTop();
        var minus = 0;
        if (pos >= sidebar_fixed_from) {
          $('#sidebar').css('top', pos - (sidebar_fixed_from - sidebar_top));
        } else {
          $('#sidebar').css('top', 'auto');
          minus = sidebar_fixed_from - pos;
        }
        $('#sidebar').css('height', 'calc(100vh - 5px - ' + minus + 'px)');
      });
      $window.trigger('scroll');
    }
});
